library questionnaire;

uses
  Windows,
  IsApi2;

{$INCLUDE ATOI.PAS}
{$INCLUDE GetErrorMessage.PAS}
{$INCLUDE Fileexists.PAS}
{$INCLUDE format.PAS}
type
  ATIStrings = array of record
    name,
      value: string;
  end;

const
  description = 'Questionnaire ISAPI DLL';
  ERROR_PAGE = '<HTML><font face="Arial"><CENTER><H2>Error occured during processing of your request</H2><br><br>%s</CENTER></font>';

function GetExtensionVersion(var pVer: THSE_VERSION_INFO): BOOL; stdcall;
begin
  pVer.dwExtensionVersion := MAKELONG(HSE_VERSION_MINOR, HSE_VERSION_MAJOR);
  pVer.lpszExtensionDesc := description + #0;
  result := true;
end;

function EscapeToAscii(str: string): string;

  function HexToAscii(c: string): byte;
  begin
    c := '$' + c;
    result := _strtoint(c);
  end;

var
  j: integer;
  pc: pchar;
  c: byte;
begin
  pc := @str[1];
  j := 1;
  while (pc[0] <> #0) do begin
    case pc[0] of
      '%':
        begin
          c := HexToAscii(pc[1] + pc[2]);
          str[j] := char(c);
          Inc(j);
          Inc(pc, 3);
        end;
    else
      begin
        str[j] := pc[0];
        Inc(pc);
        Inc(j);
      end;
    end;
  end;
  SetLength(str, j - 1);
  result := str;
end;

function GetAllparams(s: string): ATIStrings;
var po: integer;

  procedure fillarray(s1: string);
  var posi: integer;
  begin
    setlength(result, length(result) + 1);
    posi := pos('=', s1);
    if posi > 0 then begin
      result[length(result) - 1].name := EscapeToAscii(copy(s1, 1, posi - 1));
      delete(s1, 1, posi);
      if s1 <> '' then
        result[length(result) - 1].value := EscapeToAscii(s1);
    end else begin
      result[length(result) - 1].name := EscapeToAscii(s1);
      result[length(result) - 1].value := '';
    end;
  end;

begin
  setlength(result, 0);
  po := pos('&', s);
  case po > 0 of
    TRUE:
      while po > 0 do begin
        fillarray(copy(s, 1, po - 1));
        delete(s, 1, po);
        po := pos('&', s);
      end;
  end;
  Fillarray(s);
end;

function GetParam(name: string; var a: ATIstrings): string;
var i: integer;
begin
  for i := 0 to length(a) - 1 do begin
    case lstrcmpi(@a[i].name[1], @name[1]) = 0 of
      true:
        begin
          result := a[i].value;
          break;
        end;
    else result := '';
    end;
  end;
end;

function HttpExtensionProc(var pECB: TEXTENSION_CONTROL_BLOCK): DWORD; stdcall;
var
  Response,
    filebuffer: array[0..MAX_PATH] of char;
  pc: pchar;
  allparam: ATIStrings;
  SizeWritten, i, dwLen, hFileWrite, hFileRead, hMapFile: Cardinal;
  datum, page, filetoshow, param, temp,
    queryString: string;
  st: TSYSTEMTIME;

  function GetErrorPage(err: integer): string;
  begin
    result := frmt(ERROR_PAGE, [pchar(GetErrorMessage(err))]);
  end;

  function GetFileInString(filename: string): string;
  begin
    case lstrlen(@filename[1]) > 0 of
      TRUE:
        begin
          hFileRead := CreateFile(@filename[1], GENERIC_READ, 0, nil, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0);
          hMapFile := CreateFileMapping(hFileRead, nil, PAGE_READONLY, 0, 0, nil);
          pc := MapViewOfFile(hMapFile, FILE_MAP_READ, 0, 0, 0);
          SetString(result, pc, lstrlen(pc));
          UnMapViewOfFIle(pc);
          CloseHandle(hMapFile);
          CloseHandle(hFileRead);
        end;
      FALSE:
        result := GetErrorPage(2) + string(@filebuffer[0]);
    end;
  end;

  function spaceout(s: string): string;
  var i: integer;
  begin
    i := 1;
    while i <= length(s) do
      case s[i] of
        '+':
          if (i + 1) <= length(s) then
            case s[i + 1] of
              '+':
                begin
                  inc(i);
                  s[i] := ' ';
                  inc(i);
                end;
            else
              begin
                s[i] := ' ';
                inc(i);
              end;
            end else
          begin
            s[i] := ' ';
            inc(i);
          end;
      else inc(i);
      end;
    result := s;
  end;

begin
  SetString(queryString, PChar(pECB.lpbData), pECB.cbTotalBytes);
  allparam := GetAllParams(queryString);
  case lstrcmpi(pECB.lpszMethod, 'POST') of
    0:
      begin
        filetoshow := GetParam('file', allparam);
        case filetoshow = '' of
          true: page := GetErrorPage(3);
          false: if fileexists(filetoshow) then begin
              page := GetFileInString(filetoshow);
              param := Getparam('savetofile', allparam);
              if param <> '' then begin
                GetLocalTime(st);
                datum := frmt('[%u-%u-%u]', [pointer(st.wDay), pointer(st.wMonth), pointer(st.wYear)]);
                temp := '';
                if fileexists(param) then temp := GetFileInString(param);
                temp := temp + #13#10#13#10 + '------------------------------------------' + #13#10 + 'Record from ' + datum;
                for i := 0 to length(allparam) - 1 do begin
                  temp := temp + #13#10 + spaceout(allparam[i].name) + ' = ' + spaceout(allparam[i].value);
                end;
                hFileWrite := CreateFile(@param[1], GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, 0);
                pc := @temp[1];
                WriteFile(hFileWrite, pc^, length(temp), SizeWritten, nil);
                CloseHandle(hFileWrite);
              end;
            end else page := GetErrorPage(2);
        end;
      end;
  else page := GetErrorPage(20);
  end;

  page := 'Content-Type: text/html' + #13#10#13#10 + page;
  dwLen := lStrLen(@page[1]);
  lstrcpy(Response, '200 OK');
  if pECB.ServerSupportFunction(pECB.ConnID, HSE_REQ_SEND_RESPONSE_HEADER, @Response, @dwlen, @page[1]) then
    result := HSE_STATUS_SUCCESS else result := HSE_STATUS_ERROR;
end;

exports
  HttpExtensionProc,
  GetExtensionVersion;

begin
end.

